Con                                    'S2 RC receive/operate  w/encoders triggering leds

  _CLKMODE = XTAL1 + PLL16X
  _XINFREQ = 5_000_000

Var
  
Obj
    
  pwm : "s2motor_driver"
  
Pub Main | aile, elev, left, right
  
  pwm.start(4_000)         'start S2 motor driver @ 4000 hertz
  cognew(@entry, 0)        'encoders/leds cog
    
  repeat
    aile := pulse_in(0)
    elev := pulse_in(1)
    left := elev - aile
    right := elev + aile

    pwm.leftrightduty (left, right)
        
Pub pulse_in(pin) | t0, t1                      
                                            
  waitpne(1 << pin, 1 << pin, 0)            
  waitpeq(1 << pin, 1 << pin, 0)            
  t0 := cnt                                 
  waitpne(1 << pin, 1 << pin, 0)            
  t1 := cnt                                 
  return (t1 - t0) / (clkfreq / 1_000_000) - 1500

Dat
                        org 0
entry                   
                        andn outa, dirmask             
                        mov dira, dirmask
                        mov time, cnt
                        add time, period
:loop
                        test lftenc, ina        wc
              if_c      mov lights, #%1001_0000                        
              if_nc     mov lights, #%1010_0000
                        call #leds
                                  
                        waitcnt time, period
                                                                       
                        test rgtenc, ina        wc
              if_c      mov lights, #%1000_0100
              if_nc     mov lights, #%1000_1000
                        call #leds
                        
                        waitcnt time, period
                                
                        jmp #:loop    
leds                         
                        mov cntr, #8
:loop                   shr lights, #1          wc
                        muxc outa, data
                        or outa, clk
                        andn outa, clk
                        djnz cntr, #:loop
leds_ret                ret                        
                                      
lftenc        long      1 << 13
rgtenc        long      1 << 14
period        long      8_000                        
data          long      1 << 7
clk           long      1 << 8
dirmask       long      $180
cntr          res       1
lights        res       1
time          res       1                                         